Bug 894724 - Review Request: nodejs-tap - A Test Anything Protocol library
Review Request: nodejs-tap - A Test Anything Protocol library
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tom Hughes
Fedora Extras Quality Assurance
:
Depends On: 891195 891206 891210 891237 894661 894665 894666 894721 894727
Blocks: F19FeatureNodeJS
  Show dependency treegraph
 
Reported: 2013-01-13 07:50 EST by T.C. Hollingsworth
Modified: 2013-06-23 17:34 EDT (History)
5 users (show)

See Also:
Fixed In Version: nodejs-amdefine-0.0.4-2.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-05-03 20:02:54 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tom: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
%check fails: has no method 'resume' (3.64 KB, text/x-log)
2013-02-17 07:58 EST, Jamie Nguyen
no flags Details

  None (edit)
Description T.C. Hollingsworth 2013-01-13 07:50:38 EST
Spec: http://patches.fedorapeople.org/npm/tap.spec
SRPM: http://patches.fedorapeople.org/npm/tap-0.3.3-1.fc17.src.rpm
Koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=4864544
FAS username: patches

This is a mix-and-match set of utilities that you can use to write test
harnesses and frameworks that communicate with one another using the
Test Anything Protocol.

This package is part of the tap stack used to test many Node.js modules.

Please use nodejs-0.6.5-9 or later when building or using this package.
Comment 1 Michael Scherer 2013-01-13 09:14:22 EST
Shouldn't it be named "nodejs-tap", even if there is a binary there ( since the binary is mainly to support tap ) ?

and should the bootstrap stuff be also planned for porting to ARM ( or anything else, but ARM is likely to appear sooner this year )

IE, once we start to use tap in module, and module need tap, there is a circular dep that would cause issue later for arm. Should it be planned now or not ?
Comment 2 T.C. Hollingsworth 2013-01-13 09:51:41 EST
(In reply to comment #1)
> Shouldn't it be named "nodejs-tap", even if there is a binary there ( since
> the binary is mainly to support tap ) ?

I guess that does make sense.  I'll rename it.

> and should the bootstrap stuff be also planned for porting to ARM ( or
> anything else, but ARM is likely to appear sooner this year )
> 
> IE, once we start to use tap in module, and module need tap, there is a
> circular dep that would cause issue later for arm. Should it be planned now
> or not ?

Well, I can build these packages myself in the ARM Koji to ensure at least that's not a problem. ;-)

I'll make sure to conditonalize %check so other/future secondary arches can easily bootstrap as well.
Comment 3 Michael Scherer 2013-01-13 10:53:47 EST
In fact, now I think of it, that's noarch package, so maybe we will not have much issue ( ie, they could just be copied over from the stable ) ?
Comment 4 T.C. Hollingsworth 2013-01-13 17:26:29 EST
(In reply to comment #3)
> In fact, now I think of it, that's noarch package, so maybe we will not have
> much issue ( ie, they could just be copied over from the stable ) ?

Oh, I forgot, that's exactly what ARM does for noarch packages.  (pbrobinson imported a bunch of node modules into ARM already, actually)  I'll still provide facilities for bootstrapping, just in case.

(ARM's still going to get a little extra node love, since I use Fedora on ARM and there's strong interest in the Node community for supporting it.)
Comment 5 T.C. Hollingsworth 2013-01-15 04:23:01 EST
Rename complete.  I also dropped the nonfunctional bootstrapping logic; I think BuildRequiring all this package's dependencies so it can use itself to %check itself is okay.

Spec: http://patches.fedorapeople.org/npm/nodejs-tap.spec
SRPM: http://patches.fedorapeople.org/npm/nodejs-tap-0.3.3-2.fc17.src.rpm
Comment 6 Jamie Nguyen 2013-02-17 07:58:25 EST
Created attachment 698515 [details]
%check fails: has no method 'resume'

All of the BuildRequires packages need to be available in %%check:

  %check
  cp -pr %{nodejs_sitelib} .
  %__nodejs %{buildroot}%{nodejs_sitelib}/tap/bin/tap.js test/*.js


Also the tests fail. Log attached.
Comment 7 Tom Hughes 2013-04-19 03:57:58 EDT
As Jamie says, the build fails in mock due to missing requirements for the tests.
Comment 8 Lokesh Mandvekar 2013-04-19 12:08:04 EDT
T.C.: I have the same comment as Tom.

Here's the build.log: 
Start: rpmbuild -bb nodejs-tap-0.3.3-2.fc17.src.rpm
Start: Outputting list of installed packages
Finish: Outputting list of installed packages
ERROR: Exception(/home/lsm5/fedora-review/894724-nodejs-tap/srpm/nodejs-tap-0.3.3-2.fc17.src.rpm) Config(fedora-rawhide-x86_64) 1 minutes 17 seconds
INFO: Results and/or logs in: /home/lsm5/fedora-review/894724-nodejs-tap/results
ERROR: Command failed. See logs for output.
 # ['bash', '--login', '-c', 'rpmbuild -bb --target x86_64 --nodeps builddir/build/SPECS/nodejs-tap.spec']
Comment 9 T.C. Hollingsworth 2013-04-23 02:22:03 EDT
Sorry for the delay.  All tests pass now.  The one that was failing has been fixed in a patch and reported upstream:
https://github.com/isaacs/node-tap/pull/75

I also updated this to the latest upstream.

Spec: http://patches.fedorapeople.org/npm/nodejs-tap.spec
SRPM: http://patches.fedorapeople.org/npm/nodejs-tap-0.4.1-1.fc19.src.rpm
Koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID

* Tue Apr 23 2013 T.C. Hollingsworth <tchollingsworth@gmail.com> - 0.4.1-1
- new upstream release 0.4.1
- fix tests
Comment 10 T.C. Hollingsworth 2013-04-23 02:22:58 EDT
Sorry, there was a copy/paste error in the Koji scratch build.  The correct URL is:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5291633
Comment 11 Tom Hughes 2013-04-23 04:00:54 EDT
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package is named according to the Package Naming Guidelines.

I wonder if nodejs-tap or just tap is the correct name here?

- Patches link to upstream bugs/comments/lists or are otherwise justified.
- Spec file according to URL is the same as in SRPM.

Need to make sure you use the version of the spec which has
the link to the bug as the spec in the srpm differed from the
separate spec on this.

- Rpmlint is run on all installed packages.

nodejs-tap.noarch: E: non-executable-script /usr/lib/node_modules/tap/bin/tap-http.js 0644L /usr/bin/env
nodejs-tap.noarch: W: no-manual-page-for-binary tap

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[-]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[-]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 1 files have unknown license. Detailed output of
     licensecheck in /home/tom/894724-nodejs-tap/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[!]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 30720 bytes in 10 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[-]: Buildroot is not present
     Note: Buildroot: present but not needed
[-]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: nodejs-tap-0.4.1-1.fc20.noarch.rpm
nodejs-tap.noarch: W: only-non-binary-in-usr-lib
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/buffer-equal /usr/lib/node_modules/buffer-equal
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/slide /usr/lib/node_modules/slide
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/mkdirp /usr/lib/node_modules/mkdirp
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/yamlish /usr/lib/node_modules/yamlish
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/runforcover /usr/lib/node_modules/runforcover
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/difflet /usr/lib/node_modules/difflet
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/deep-equal /usr/lib/node_modules/deep-equal
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/inherits /usr/lib/node_modules/inherits
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/glob /usr/lib/node_modules/glob
nodejs-tap.noarch: E: non-executable-script /usr/lib/node_modules/tap/bin/tap-http.js 0644L /usr/bin/env
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/nopt /usr/lib/node_modules/nopt
nodejs-tap.noarch: W: no-manual-page-for-binary tap
1 packages and 0 specfiles checked; 1 errors, 12 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint nodejs-tap
nodejs-tap.noarch: W: only-non-binary-in-usr-lib
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/buffer-equal /usr/lib/node_modules/buffer-equal
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/slide /usr/lib/node_modules/slide
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/mkdirp /usr/lib/node_modules/mkdirp
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/yamlish /usr/lib/node_modules/yamlish
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/runforcover /usr/lib/node_modules/runforcover
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/difflet /usr/lib/node_modules/difflet
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/deep-equal /usr/lib/node_modules/deep-equal
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/inherits /usr/lib/node_modules/inherits
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/glob /usr/lib/node_modules/glob
nodejs-tap.noarch: E: non-executable-script /usr/lib/node_modules/tap/bin/tap-http.js 0644L /usr/bin/env
nodejs-tap.noarch: W: dangling-symlink /usr/lib/node_modules/tap/node_modules/nopt /usr/lib/node_modules/nopt
nodejs-tap.noarch: W: no-manual-page-for-binary tap
1 packages and 0 specfiles checked; 1 errors, 12 warnings.
# echo 'rpmlint-done:'



Diff spec file in url and in SRPM
---------------------------------
--- /home/tom/894724-nodejs-tap/srpm/nodejs-tap.spec	2013-04-23 08:26:38.176521868 +0100
+++ /home/tom/894724-nodejs-tap/srpm-unpacked/nodejs-tap.spec	2013-04-23 08:26:39.407519628 +0100
@@ -13,5 +13,5 @@
 
 # the segv test results in SIGSEGV as you would expect, not SIGBUS as is written
-# in the test:  https://github.com/isaacs/node-tap/pull/75
+# in the test
 Patch1:         nodejs-tap-segv-actually-segfaults.patch
 


Requires
--------
nodejs-tap (rpmlib, GLIBC filtered):
    /usr/bin/env
    nodejs(engine)
    npm(buffer-equal)
    npm(deep-equal)
    npm(difflet)
    npm(glob)
    npm(inherits)
    npm(mkdirp)
    npm(nopt)
    npm(runforcover)
    npm(slide)
    npm(yamlish)



Provides
--------
nodejs-tap:
    nodejs-tap
    npm(tap)



MD5-sum check
-------------
http://registry.npmjs.org/tap/-/tap-0.4.1.tgz :
  CHECKSUM(SHA256) this package     : c36d102a16392bb405d136837db7268f059882ecf784ff9e7925e8999fbaa720
  CHECKSUM(SHA256) upstream package : c36d102a16392bb405d136837db7268f059882ecf784ff9e7925e8999fbaa720


Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: compton-rawhide-x86_64
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 894724
Comment 12 T.C. Hollingsworth 2013-04-23 04:14:13 EDT
(In reply to comment #11)
> Issues:
> =======
> - Package is named according to the Package Naming Guidelines.
> 
> I wonder if nodejs-tap or just tap is the correct name here?

Earlier on we decided to rename because there are multiple implementations of the Test Anything Protocol (TAP).  (The Perl version is probably more widely used.  ;-)
 
> - Patches link to upstream bugs/comments/lists or are otherwise justified.
> - Spec file according to URL is the same as in SRPM.
> 
> Need to make sure you use the version of the spec which has
> the link to the bug as the spec in the srpm differed from the
> separate spec on this.

Sorry, forgot to rebuild after I added the upstream pull request link.

> - Rpmlint is run on all installed packages.
> 
> nodejs-tap.noarch: E: non-executable-script
> /usr/lib/node_modules/tap/bin/tap-http.js 0644L /usr/bin/env

Fixed.

> nodejs-tap.noarch: W: no-manual-page-for-binary tap

This is in my queue of man pages to write.

---

Spec: http://patches.fedorapeople.org/npm/nodejs-tap.spec
SRPM: http://patches.fedorapeople.org/npm/nodejs-tap-0.4.1-2.fc19.src.rpm

* Tue Apr 23 2013 T.C. Hollingsworth <tchollingsworth@gmail.com> - 0.4.1-2
- fix rpmlint warnings
Comment 13 Tom Hughes 2013-04-23 04:17:18 EDT
(In reply to comment #12)
> (In reply to comment #11)
> > Issues:
> > =======
> > - Package is named according to the Package Naming Guidelines.
> > 
> > I wonder if nodejs-tap or just tap is the correct name here?
> 
> Earlier on we decided to rename because there are multiple implementations
> of the Test Anything Protocol (TAP).  (The Perl version is probably more
> widely used.  ;-)

Yes I realised that might be an issue, and that it was a close call.

Of course it just means the fight may move to the rights to /usr/bin/tap and /etc/rpm/macros.tap but we can deal with that if it ever happens.

So I think we can say package is approved.
Comment 14 T.C. Hollingsworth 2013-04-23 04:24:40 EDT
Luckily, Perl doesn't use /usr/bin/tap so it isn't a problem for now.  This is also one of the reasons I created a %tap macro, so we don't have to change specs if the binary moves later on.

Thanks for the review!

New Package SCM Request
=======================
Package Name: nodejs-tap
Short Description: A Test Anything Protocol library
Owners: patches
Branches: f19 f18 el6
InitialCC:
Comment 15 Fedora Update System 2013-04-23 04:26:40 EDT
nodejs-dryice-0.4.10-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/nodejs-dryice-0.4.10-1.el6
Comment 16 Jon Ciesla 2013-04-23 08:00:27 EDT
Git done (by process-git-requests).
Comment 17 Fedora Update System 2013-04-24 21:55:50 EDT
nodejs-tap-0.4.1-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/nodejs-tap-0.4.1-2.fc18
Comment 18 Fedora Update System 2013-04-24 21:57:16 EDT
nodejs-tap-0.4.1-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/nodejs-tap-0.4.1-2.fc19
Comment 19 Fedora Update System 2013-04-24 22:07:41 EDT
nodejs-amdefine-0.0.4-2.el6, nodejs-buffer-equal-0.0.0-2.el6, nodejs-bunker-0.1.2-2.el6, nodejs-burrito-0.2.12-5.el6, nodejs-charm-0.1.2-1.el6, nodejs-deep-equal-0.0.0-2.el6, nodejs-optimist-0.4.0-1.el6, nodejs-runforcover-0.0.2-3.el6, nodejs-source-map-0.1.22-1.el6, nodejs-traverse-0.6.3-3.el6, nodejs-wordwrap-0.0.2-2.el6, nodejs-yamlish-0.0.5-3.el6, nodejs-difflet-0.2.3-3.el6, nodejs-tap-0.4.1-2.el6, uglify-js1-1.3.4-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/FEDORA-EPEL-2013-5457/nodejs-amdefine-0.0.4-2.el6,nodejs-buffer-equal-0.0.0-2.el6,nodejs-bunker-0.1.2-2.el6,nodejs-burrito-0.2.12-5.el6,nodejs-charm-0.1.2-1.el6,nodejs-deep-equal-0.0.0-2.el6,nodejs-optimist-0.4.0-1.el6,nodejs-runforcover-0.0.2-3.el6,nodejs-source-map-0.1.22-1.el6,nodejs-traverse-0.6.3-3.el6,nodejs-wordwrap-0.0.2-2.el6,nodejs-yamlish-0.0.5-3.el6,uglify-js1-1.3.4-1.el6,nodejs-difflet-0.2.3-3.el6,nodejs-tap-0.4.1-2.el6
Comment 20 Fedora Update System 2013-04-25 12:45:48 EDT
nodejs-tap-0.4.1-2.fc19 has been pushed to the Fedora 19 testing repository.
Comment 21 Fedora Update System 2013-05-03 20:02:56 EDT
nodejs-tap-0.4.1-2.fc18 has been pushed to the Fedora 18 stable repository.
Comment 22 Fedora Update System 2013-05-03 21:45:09 EDT
nodejs-tap-0.4.1-2.fc19 has been pushed to the Fedora 19 stable repository.
Comment 23 Fedora Update System 2013-06-23 17:34:28 EDT
nodejs-amdefine-0.0.4-2.el6, nodejs-buffer-equal-0.0.0-2.el6, nodejs-bunker-0.1.2-2.el6, nodejs-burrito-0.2.12-5.el6, nodejs-charm-0.1.2-1.el6, nodejs-deep-equal-0.0.0-2.el6, nodejs-optimist-0.4.0-1.el6, nodejs-runforcover-0.0.2-3.el6, nodejs-source-map-0.1.22-1.el6, nodejs-traverse-0.6.3-3.el6, nodejs-wordwrap-0.0.2-2.el6, nodejs-yamlish-0.0.5-3.el6, nodejs-difflet-0.2.3-3.el6, nodejs-tap-0.4.1-2.el6, uglify-js1-1.3.4-1.el6 has been pushed to the Fedora EPEL 6 stable repository.

Note You need to log in before you can comment on or make changes to this bug.